package ssl_client_test;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.KeyStore;

import javax.net.ssl.KeyManagerFactory;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLHandshakeException;
import javax.net.ssl.SSLSocket;
import javax.net.ssl.TrustManagerFactory;

import ssl_client.CertHelper;

public class SSLTestClient {
	private static final String CLIENT_KEYSTORE = "F:/ejbca/p12/tmp/ejbcakclient.jks";
	private static final String CLIENT_KEYSTORE_PWD = "123456";

	public static void main(String[] args) throws Exception {
		SSLContext ctx = SSLContext.getInstance("SSL");

		KeyManagerFactory kmf = KeyManagerFactory.getInstance("SunX509");
		TrustManagerFactory tmf = TrustManagerFactory.getInstance("SunX509");

		KeyStore ks = KeyStore.getInstance("JKS");
		KeyStore tks = KeyStore.getInstance("JKS");

		ks.load(new FileInputStream(CLIENT_KEYSTORE),
				CLIENT_KEYSTORE_PWD.toCharArray());
		tks.load(new FileInputStream(CLIENT_KEYSTORE),
				CLIENT_KEYSTORE_PWD.toCharArray());

		kmf.init(ks, "123456".toCharArray());
		tmf.init(tks);

		ctx.init(kmf.getKeyManagers(), tmf.getTrustManagers(), null);
		SSLSocket sslSocket = (SSLSocket) ctx.getSocketFactory().createSocket(
				"localhost", 7071);
		try {
			sslSocket.startHandshake();
		} catch (SSLHandshakeException e) {
			System.out.println("ͻδܰװ֤,Զװ֤...");
			boolean result = CertHelper.intallCert(CLIENT_KEYSTORE,
					CLIENT_KEYSTORE_PWD, "localhost", 7071);
			if (result) {
				System.out.println("мɽȫ.");
			} else {
				System.out.println("װ֤ʧ.");
			}
			System.exit(0);
		} catch (Exception e) {
			System.out.println(e);
			System.exit(0);
		}
		InputStream input = sslSocket.getInputStream();
		OutputStream utput = sslSocket.getOutputStream();

		BufferedInputStream bis = new BufferedInputStream(input);
		BufferedOutputStream bos = new BufferedOutputStream(utput);

		bos.write("Hello,I am client".getBytes());
		bos.flush();

		byte[] buffer = new byte[20];
		int length = bis.read(buffer);
		System.out.println(new String(buffer, 0, length));

		sslSocket.close();
	}

}